package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineUserProfitLogs struct {
	api.Api
}

// GetPage 获取会员盈利记录表列表
// @Summary 获取会员盈利记录表列表
// @Description 获取会员盈利记录表列表
// @Tags 会员盈利记录表
// @Param userId query int64 false "line_user 表的id"
// @Param apiId query int64 false "line_apiuser 表的id"
// @Param preOrderId query int64 false "line_pre_order 主订单id"
// @Param num query string false "成交数量"
// @Param symbol query string false "交易对"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineUserProfitLogs}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-user-profit-logs [get]
// @Security Bearer
func (e LineUserProfitLogs) GetPage(c *gin.Context) {
    req := dto.LineUserProfitLogsGetPageReq{}
    s := service.LineUserProfitLogs{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineUserProfitLogs, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取会员盈利记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取会员盈利记录表
// @Summary 获取会员盈利记录表
// @Description 获取会员盈利记录表
// @Tags 会员盈利记录表
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineUserProfitLogs} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-user-profit-logs/{id} [get]
// @Security Bearer
func (e LineUserProfitLogs) Get(c *gin.Context) {
	req := dto.LineUserProfitLogsGetReq{}
	s := service.LineUserProfitLogs{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineUserProfitLogs

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取会员盈利记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建会员盈利记录表
// @Summary 创建会员盈利记录表
// @Description 创建会员盈利记录表
// @Tags 会员盈利记录表
// @Accept application/json
// @Product application/json
// @Param data body dto.LineUserProfitLogsInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-user-profit-logs [post]
// @Security Bearer
func (e LineUserProfitLogs) Insert(c *gin.Context) {
    req := dto.LineUserProfitLogsInsertReq{}
    s := service.LineUserProfitLogs{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建会员盈利记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改会员盈利记录表
// @Summary 修改会员盈利记录表
// @Description 修改会员盈利记录表
// @Tags 会员盈利记录表
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineUserProfitLogsUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-user-profit-logs/{id} [put]
// @Security Bearer
func (e LineUserProfitLogs) Update(c *gin.Context) {
    req := dto.LineUserProfitLogsUpdateReq{}
    s := service.LineUserProfitLogs{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改会员盈利记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除会员盈利记录表
// @Summary 删除会员盈利记录表
// @Description 删除会员盈利记录表
// @Tags 会员盈利记录表
// @Param data body dto.LineUserProfitLogsDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-user-profit-logs [delete]
// @Security Bearer
func (e LineUserProfitLogs) Delete(c *gin.Context) {
    s := service.LineUserProfitLogs{}
    req := dto.LineUserProfitLogsDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除会员盈利记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
